org.apache.cassandra.db.marshal

## Class TimeType

- java.lang.Object
- - org.apache.cassandra.db.marshal.AbstractType<java.lang.Long>
  - - org.apache.cassandra.db.marshal.TimeType

All Implemented Interfaces:
  java.util.Comparator<java.nio.ByteBuffer>, AssignmentTestable

    public class TimeType
    extends AbstractType<java.lang.Long>

Nanosecond resolution time values

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.cassandra.db.marshal.AbstractType

`AbstractType.ComparisonType`

### Nested classes/interfaces inherited from interface org.apache.cassandra.cql3.AssignmentTestable

`AssignmentTestable.TestResult`

### Field Summary

Fields
`static TimeType` `instance`

### Fields inherited from class org.apache.cassandra.db.marshal.AbstractType

`comparisonType, isByteOrderComparable, reverseComparator`

### Method Summary

All Methods Instance Methods Concrete Methods
`CQL3Type` `asCQL3Type()`
`Term` `fromJSONObject(java.lang.Object parsed)` Given a parsed JSON string, return a byte representation of the object.
`java.nio.ByteBuffer` `fromString(java.lang.String source)` get a byte representation of the given string.
`TypeSerializer<java.lang.Long>` `getSerializer()`
`boolean` `isValueCompatibleWithInternal(AbstractType<?> otherType)` Needed to handle ReversedType in value-compatibility checks.
`java.lang.String` `toJSONString(java.nio.ByteBuffer buffer, ProtocolVersion protocolVersion)` Converts the specified value into its JSON representation.

### Methods inherited from class org.apache.cassandra.db.marshal.AbstractType

`asCQLTypeStringList, checkComparable, compare, compareCollectionMembers, compareCustom, compareForCQL, componentsCount, compose, decompose, equals, freeze, freezeNestedMulticellTypes, getComponents, getString, getString, isCollection, isCompatibleWith, isCounter, isEmptyValueMeaningless, isFreezable, isFrozenCollection, isMultiCell, isReversed, isTuple, isUDT, isValueCompatibleWith, parseDefaultParameters, readValue, readValue, referencesDuration, referencesUserType, skipValue, testAssignment, toString, toString, validate, validateCellValue, validateCollectionMember, valueLengthIfFixed, writeValue, writtenLength`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.util.Comparator

`comparing, comparing, comparingDouble, comparingInt, comparingLong, equals, naturalOrder, nullsFirst, nullsLast, reversed, reverseOrder, thenComparing, thenComparing, thenComparing, thenComparingDouble, thenComparingInt, thenComparingLong`

### Field Detail

#### instance

    public static final TimeType instance

### Method Detail

#### fromString

    public java.nio.ByteBuffer fromString(java.lang.String source)
                                   throws MarshalException

Description copied from class: `AbstractType`
get a byte representation of the given string.

Specified by:
  `fromString` in class `AbstractType<java.lang.Long>`
Throws:
  `MarshalException`

#### isValueCompatibleWithInternal

    public boolean isValueCompatibleWithInternal(AbstractType<?> otherType)

Description copied from class: `AbstractType`
Needed to handle ReversedType in value-compatibility checks. Subclasses should implement this instead of isValueCompatibleWith().

Overrides:
  `isValueCompatibleWithInternal` in class `AbstractType<java.lang.Long>`

#### fromJSONObject

    public Term fromJSONObject(java.lang.Object parsed)
                        throws MarshalException

Description copied from class: `AbstractType`
Given a parsed JSON string, return a byte representation of the object.

Specified by:
  `fromJSONObject` in class `AbstractType<java.lang.Long>`
Parameters:
  `parsed` - the result of parsing a json string
Throws:
  `MarshalException`

#### toJSONString

    public java.lang.String toJSONString(java.nio.ByteBuffer buffer,
                                         ProtocolVersion protocolVersion)

Description copied from class: `AbstractType`
Converts the specified value into its JSON representation.

The buffer position will stay the same.

Overrides:
  `toJSONString` in class `AbstractType<java.lang.Long>`
Parameters:
  `buffer` - the value to convert
  `protocolVersion` - the protocol version to use for the conversion
Returns:
  a JSON string representing the specified value

#### asCQL3Type

    public CQL3Type asCQL3Type()

Overrides:
  `asCQL3Type` in class `AbstractType<java.lang.Long>`

#### getSerializer

    public TypeSerializer<java.lang.Long> getSerializer()

Specified by:
  `getSerializer` in class `AbstractType<java.lang.Long>`